#include <math.h>

void choldc (a,  n,  p)
double *a;
int n;
double *p;
{

   int i,j,k;
   double sum;

   for(i=0; i<n; i++){
	for(j=i; j<n;j++){
	   for(sum=a[i+j*n], k=i-1; k>=0; k--)  sum-=a[i+k*n]*a[j+k*n];
	   if (i==j){
	       if(sum<=0.0){
		     mexPrintf(" choldc failed");
                    exit(1);   /* exit at the first failure */
                    }
	      p[i]=sqrt(sum);
	  } else a[j+i*n]=sum/p[i];
	 }
      }
  }


