void  newsy(k, N, NObs, N01, N01A, NZ, ROW, UPPSX, CLM, ETA, LY, NEYO, PLY, PSLY, PSI, PSIG,idum)
int      k, N,  ROW,   *CLM, NObs,  N01, *N01A, NZ;
double   *ETA, *PSI;
double UPPSX;
double   *LY,  *PLY, *PSLY,  *NEYO, *PSIG; 
long *idum;
{
    int    i, j, j1, j2, m, n, n1, itmp, NAL;
    /*long   radom;*/
    double  AA, AK;
    double  *SIMG, *AMU, *COL, *PP;
    double  *imaf, *XX;
    
    SIMG=(double *)mxMalloc(sizeof(double)*ROW*ROW+1);/*+1 still allocate sth when ROW==0*/
    imaf=(double *)mxMalloc(sizeof(double)*ROW*ROW+1);
    AMU=(double *)mxMalloc(sizeof(double)*ROW+1);
    COL=(double *)mxMalloc(sizeof(double)*ROW+1);
    PP=(double *)mxMalloc(sizeof(double)*ROW+1);
    XX=(double *)mxMalloc(sizeof(double)*ROW+1);
    
	NAL=NObs*N01;
	
    for(i=0;i<ROW;i++){
        for(j=0;j<=i;j++){
            n1=CLM[k+i*NZ];
            n=CLM[k+j*NZ];
			SIMG[i+j*ROW]=0.0;
            /*for(m=0;m<NAL;m++)
                SIMG[i+j*ROW]+=ETA[m+n1*NAL]*ETA[m+n*NAL];*/
			for(j1=0;j1<NObs;j1++){
				itmp=N01A[j1];
				for(j2=1;j2<itmp;j2++){
					m=j1*N01+j2;
					SIMG[i+j*ROW]+=ETA[m+n1*NAL]*ETA[m+n*NAL];
				}
			}
        }
    }
	for(i=0;i<ROW;i++){
        for(j=i+1;j<ROW;j++){
			SIMG[i+j*ROW]=SIMG[j+i*ROW];
		}
	}
	
    for(i=0;i<ROW; i++){
        n=CLM[k+i*NZ];
		AMU[i]=PLY[k+n*NZ]/PSLY[k+n*NZ];        
		j=n*NAL;
        /*for(m=0; m<NAL;m++){			
            AMU[i]+=NEYO[m]*ETA[m+j];
        }*/
			for(j1=0;j1<NObs;j1++){
				itmp=N01A[j1];
				for(j2=1;j2<itmp;j2++){
					m=j1*N01+j2;
					AMU[i]+=NEYO[m]*ETA[m+j];
				}
			}		
    }
    for(i=0;i<ROW;i++){
		n=CLM[k+i*NZ];
        for(j=0;j<ROW;j++){        
			imaf[i+j*ROW]=SIMG[i+j*ROW];        
        }
		imaf[i+i*ROW]+=1/PSLY[k+n*NZ];
	}
	
    if(ROW>0){
        choldc(imaf, ROW, PP);
        for(m=0;m<ROW;m++){
            for(i=0;i<ROW;i++){
                COL[i]=0.0;
			}
            COL[m]=1.0;
            cholsl(imaf, ROW, PP, COL, XX);
            for(i=0; i<ROW;i++){
				SIMG[i+m*ROW]=XX[i];
			}
        }
    }
    
    for(m=0;m<ROW;m++){
        for(j=0;j<ROW;j++){
            imaf[m+j*ROW]=SIMG[m+j*ROW];
		}
    }
	
	if(ROW>0){
		choldc(imaf, ROW, PP);
	}
	
    for(m=0; m<ROW;m++){
        for(i=(m+1);i<ROW;i++){
			imaf[m+i*ROW]=0.0;
        }
		imaf[m+m*ROW]=PP[m];
	}
    
    
    AK=PSIG[k+NZ];
    
	/*
	for(i=0;i<NAL;i++){
        AK+=0.5*NEYO[i]*NEYO[i];
	}
	*/
	for(j1=0;j1<NObs;j1++){
		itmp=N01A[j1];
		for(j2=1;j2<itmp;j2++){
			m=j1*N01+j2;
			AK+=0.5*NEYO[m]*NEYO[m];					
		}
	}	
	
	
	
    for(i=0;i<ROW;i++){
        m=CLM[k+i*NZ];
		AK+=0.5*PLY[k+m*NZ]*PLY[k+m*NZ]/PSLY[k+m*NZ];
	}
    for(i=0;i<ROW;i++){
        XX[i]=0.0;
        for(j=0;j<ROW;j++){
            XX[i]+=SIMG[i+j*ROW]*AMU[j];
		}
        AK-=0.5*AMU[i]*XX[i];
    }
    
    
    /*radom=rand();*/
    if(UPPSX==1){
        if(N%2==0){
			m=(int) (N/2+PSIG[k]);
            PSI[k]=AK/gamdev(m, idum);
		}else {
			m=(int) ((N-1)/2+PSIG[k]);
            AA=gasdev(idum);
            /*radom=rand();*/
            PSI[k]=AK/(gamdev(m, idum)+0.5*AA*AA);
        }
    }
    for(i=0;i<ROW;i++){
        /*radom=rand();*/
        PP[i]=gasdev(idum);
    }
    for(i=0;i<ROW;i++){
        for(j=0;j<ROW;j++){
            XX[i]+=sqrt(PSI[k])*imaf[i+j*ROW]*PP[j];
		}
	}
    for(i=0;i<ROW;i++){
        m=CLM[k+i*NZ];
        LY[k+m*NZ]=XX[i];
    }
    
    
    mxFree(XX);
    mxFree(PP);
    mxFree(COL);
    mxFree(AMU);
    mxFree(imaf);
    mxFree(SIMG);
}/*end of newsy.c */
